#!/usr/bin/python

import os,sys

# Print appropriate number of <ul> or </ul> tags, with indentation.
def adjust_depth(newdepth, depth):
  while newdepth > depth:
    sys.stdout.write("%s<ul>\n" % ("  "*depth))
    depth += 1
  while newdepth < depth:
    sys.stdout.write("%s</ul>\n" % ("  "*depth))
    depth -= 1

def process(data, idx):
  line = data[0].count("\n")
  depth = 0
  spans = []
  secnum = [0]

  if not idx: sys.stdout.write(data[0])
  for i in data[1:]:
    i = i.split(">",1)
    tag = i[0].split(None,1)
    if tag[0] == "put_index_here":
      if not idx: process(data, 1)
      continue
    if tag[0] == "span":
      if len(tag) == 0 or not tag[1].startswith("id="):
        sys.stderr.write("Bad span at line %s: %s" % (line,i[0]))
        sys.exit(1)
      tag = tag[1][3:]
      if tag[0]=='"' and tag[-1]=='"': tag=tag[1:-1]
      spans.append("_".join(tag.split()))
      secnum[-1] += 1
      secstr = ".".join(map(lambda a: str(a), secnum))
      if idx:
        adjust_depth(len(spans), depth)
        depth = len(spans)
        sys.stdout.write('%s<li><a href="#%s">%s %s</a></li>\n' % ("  "*len(spans),spans[-1],secstr,tag))
      else:
        sys.stdout.write('<h2><a name="%s">%s %s</a></h2>\n' % (spans[-1],secstr,tag))
        sys.stdout.write('<%s>%s' % (i[0], i[1]))
      secnum.append(0)
    elif tag[0] == "/span":
      spans.pop()
      secnum.pop()
    else:
      if not idx: sys.stdout.write('<%s>%s' % (i[0], i[1]));
    line += i[1].count("\n")
  if idx: adjust_depth(0, depth)

if len(sys.argv) != 2:
  sys.stderr.write("Usage: indexsections.py filename\n");
  sys.exit(1)

process(open(sys.argv[1]).read().split("<"), 0)
